Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 627)
+++ CMakeLists.txt	(revision 621)
@@ -29,8 +29,6 @@
 ENDIF(MSVC)
 
-ADD_DEFINITIONS(-DHAVE_CONFIG_H)
-
 INCLUDE(CheckTypeSize)
-CHECK_TYPE_SIZE("long long" LEMON_LONG_LONG)
+CHECK_TYPE_SIZE("long long" LONG_LONG)
 
 ENABLE_TESTING()
Index: cmake/FindCOIN.cmake
===================================================================
--- cmake/FindCOIN.cmake	(revision 627)
+++ cmake/FindCOIN.cmake	(revision 621)
@@ -62,7 +62,7 @@
 
 IF(COIN_FOUND)
-  SET(LEMON_HAVE_LP TRUE)
-  SET(LEMON_HAVE_MIP TRUE)
-  SET(LEMON_HAVE_CLP TRUE)
-  SET(LEMON_HAVE_CBC TRUE)
+  SET(HAVE_LP TRUE)
+  SET(HAVE_MIP TRUE)
+  SET(HAVE_CLP TRUE)
+  SET(HAVE_CBC TRUE)
 ENDIF(COIN_FOUND)
Index: cmake/FindCPLEX.cmake
===================================================================
--- cmake/FindCPLEX.cmake	(revision 627)
+++ cmake/FindCPLEX.cmake	(revision 620)
@@ -22,6 +22,6 @@
 
 IF(CPLEX_FOUND)
-  SET(LEMON_HAVE_LP TRUE)
-  SET(LEMON_HAVE_MIP TRUE)
-  SET(LEMON_HAVE_CPLEX TRUE)
+  SET(HAVE_LP TRUE)
+  SET(HAVE_MIP TRUE)
+  SET(HAVE_CPLEX TRUE)
 ENDIF(CPLEX_FOUND)
Index: cmake/FindGLPK.cmake
===================================================================
--- cmake/FindGLPK.cmake	(revision 627)
+++ cmake/FindGLPK.cmake	(revision 619)
@@ -22,6 +22,6 @@
 
 IF(GLPK_FOUND)
-  SET(LEMON_HAVE_LP TRUE)
-  SET(LEMON_HAVE_MIP TRUE)
-  SET(LEMON_HAVE_GLPK TRUE)
+  SET(HAVE_LP TRUE)
+  SET(HAVE_MIP TRUE)
+  SET(HAVE_GLPK TRUE)
 ENDIF(GLPK_FOUND)
Index: configure.ac
===================================================================
--- configure.ac	(revision 627)
+++ configure.ac	(revision 568)
@@ -26,5 +26,5 @@
 AC_CHECK_TYPE(long long, [long_long_found=yes], [long_long_found=no])
 if test x"$long_long_found" = x"yes"; then
-  AC_DEFINE([LEMON_HAVE_LONG_LONG], [1], [Define to 1 if you have long long.])
+  AC_DEFINE([HAVE_LONG_LONG], [1], [Define to 1 if you have long long.])
 fi
 
Index: lemon/CMakeLists.txt
===================================================================
--- lemon/CMakeLists.txt	(revision 627)
+++ lemon/CMakeLists.txt	(revision 621)
@@ -19,5 +19,5 @@
 )
 
-IF(LEMON_HAVE_GLPK)
+IF(HAVE_GLPK)
   SET(LEMON_SOURCES ${LEMON_SOURCES} glpk.cc)
   INCLUDE_DIRECTORIES(${GLPK_INCLUDE_DIRS})
@@ -27,20 +27,20 @@
     INSTALL(FILES ${GLPK_BIN_DIR}/zlib1.dll DESTINATION bin)
   ENDIF(WIN32)
-ENDIF(LEMON_HAVE_GLPK)
+ENDIF(HAVE_GLPK)
 
-IF(LEMON_HAVE_CPLEX)
+IF(HAVE_CPLEX)
   SET(LEMON_SOURCES ${LEMON_SOURCES} cplex.cc)
   INCLUDE_DIRECTORIES(${CPLEX_INCLUDE_DIRS})
-ENDIF(LEMON_HAVE_CPLEX)
+ENDIF(HAVE_CPLEX)
 
-IF(LEMON_HAVE_CLP)
+IF(HAVE_CLP)
   SET(LEMON_SOURCES ${LEMON_SOURCES} clp.cc)
   INCLUDE_DIRECTORIES(${COIN_INCLUDE_DIRS})
-ENDIF(LEMON_HAVE_CLP)
+ENDIF(HAVE_CLP)
 
-IF(LEMON_HAVE_CBC)
+IF(HAVE_CBC)
   SET(LEMON_SOURCES ${LEMON_SOURCES} cbc.cc)
   INCLUDE_DIRECTORIES(${COIN_INCLUDE_DIRS})
-ENDIF(LEMON_HAVE_CBC)
+ENDIF(HAVE_CBC)
 
 ADD_LIBRARY(lemon ${LEMON_SOURCES})
@@ -56,7 +56,2 @@
   COMPONENT headers
   FILES_MATCHING PATTERN "*.h")
-
-INSTALL(
-  FILES ${CMAKE_CURRENT_BINARY_DIR}/config.h
-  DESTINATION include/lemon
-  COMPONENT headers)
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 627)
+++ lemon/Makefile.am	(revision 611)
@@ -62,5 +62,4 @@
 	lemon/color.h \
 	lemon/concept_check.h \
-	lemon/config.h \
 	lemon/connectivity.h \
 	lemon/counter.h \
Index: lemon/bits/default_map.h
===================================================================
--- lemon/bits/default_map.h	(revision 627)
+++ lemon/bits/default_map.h	(revision 617)
@@ -98,5 +98,5 @@
 
 
-#if defined LEMON_HAVE_LONG_LONG
+#if defined HAVE_LONG_LONG
 
   // long long
Index: lemon/config.h.cmake
===================================================================
--- lemon/config.h.cmake	(revision 627)
+++ lemon/config.h.cmake	(revision 621)
@@ -1,7 +1,7 @@
-#cmakedefine LEMON_HAVE_LONG_LONG 1
-#cmakedefine LEMON_HAVE_LP 1
-#cmakedefine LEMON_HAVE_MIP 1
-#cmakedefine LEMON_HAVE_GLPK 1
-#cmakedefine LEMON_HAVE_CPLEX 1
-#cmakedefine LEMON_HAVE_CLP 1
-#cmakedefine LEMON_HAVE_CBC 1
+#cmakedefine HAVE_LONG_LONG 1
+#cmakedefine HAVE_LP 1
+#cmakedefine HAVE_MIP 1
+#cmakedefine HAVE_GLPK 1
+#cmakedefine HAVE_CPLEX 1
+#cmakedefine HAVE_CLP 1
+#cmakedefine HAVE_CBC 1
Index: lemon/config.h.in
===================================================================
--- lemon/config.h.in	(revision 627)
+++ lemon/config.h.in	(revision 567)
@@ -1,23 +1,23 @@
 /* Define to 1 if you have long long */
-#undef LEMON_HAVE_LONG_LONG
+#undef HAVE_LONG_LONG
 
 /* Define to 1 if you have any LP solver. */
-#undef LEMON_HAVE_LP
+#undef HAVE_LP
 
 /* Define to 1 if you have any MIP solver. */
-#undef LEMON_HAVE_MIP
+#undef HAVE_MIP
 
 /* Define to 1 if you have CPLEX. */
-#undef LEMON_HAVE_CPLEX
+#undef HAVE_CPLEX
 
 /* Define to 1 if you have GLPK. */
-#undef LEMON_HAVE_GLPK
+#undef HAVE_GLPK
 
 /* Define to 1 if you have SOPLEX */
-#undef LEMON_HAVE_SOPLEX
+#undef HAVE_SOPLEX
 
 /* Define to 1 if you have CLP */
-#undef LEMON_HAVE_CLP
+#undef HAVE_CLP
 
 /* Define to 1 if you have CBC */
-#undef LEMON_HAVE_CBC
+#undef HAVE_CBC
Index: lemon/lp.h
===================================================================
--- lemon/lp.h	(revision 627)
+++ lemon/lp.h	(revision 462)
@@ -23,11 +23,11 @@
 
 
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
 #include <lemon/glpk.h>
-#elif LEMON_HAVE_CPLEX
+#elif HAVE_CPLEX
 #include <lemon/cplex.h>
-#elif LEMON_HAVE_SOPLEX
+#elif HAVE_SOPLEX
 #include <lemon/soplex.h>
-#elif LEMON_HAVE_CLP
+#elif HAVE_CLP
 #include <lemon/clp.h>
 #endif
@@ -70,18 +70,18 @@
   typedef GlpkMip Mip;
 #else
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
 # define LEMON_DEFAULT_LP GLPK
   typedef GlpkLp Lp;
 # define LEMON_DEFAULT_MIP GLPK
   typedef GlpkMip Mip;
-#elif LEMON_HAVE_CPLEX
+#elif HAVE_CPLEX
 # define LEMON_DEFAULT_LP CPLEX
   typedef CplexLp Lp;
 # define LEMON_DEFAULT_MIP CPLEX
   typedef CplexMip Mip;
-#elif LEMON_HAVE_SOPLEX
+#elif HAVE_SOPLEX
 # define DEFAULT_LP SOPLEX
   typedef SoplexLp Lp;
-#elif LEMON_HAVE_CLP
+#elif HAVE_CLP
 # define DEFAULT_LP CLP
   typedef ClpLp Lp;  
Index: m4/lx_check_coin.m4
===================================================================
--- m4/lx_check_coin.m4	(revision 627)
+++ m4/lx_check_coin.m4	(revision 568)
@@ -56,7 +56,7 @@
 
     if test x"$lx_clp_found" = x"yes"; then
-      AC_DEFINE([LEMON_HAVE_CLP], [1], [Define to 1 if you have CLP.])
+      AC_DEFINE([HAVE_CLP], [1], [Define to 1 if you have CLP.])
       lx_lp_found=yes
-      AC_DEFINE([LEMON_HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+      AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
       AC_MSG_RESULT([yes])
     else
@@ -116,9 +116,9 @@
 
       if test x"$lx_cbc_found" = x"yes"; then
-        AC_DEFINE([LEMON_HAVE_CBC], [1], [Define to 1 if you have CBC.])
+        AC_DEFINE([HAVE_CBC], [1], [Define to 1 if you have CBC.])
         lx_lp_found=yes
-        AC_DEFINE([LEMON_HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+        AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
         lx_mip_found=yes
-        AC_DEFINE([LEMON_HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
+        AC_DEFINE([HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
         AC_MSG_RESULT([yes])
       else
Index: m4/lx_check_cplex.m4
===================================================================
--- m4/lx_check_cplex.m4	(revision 627)
+++ m4/lx_check_cplex.m4	(revision 457)
@@ -62,9 +62,9 @@
 
     if test x"$lx_cplex_found" = x"yes"; then
-      AC_DEFINE([LEMON_HAVE_CPLEX], [1], [Define to 1 if you have CPLEX.])
+      AC_DEFINE([HAVE_CPLEX], [1], [Define to 1 if you have CPLEX.])
       lx_lp_found=yes
-      AC_DEFINE([LEMON_HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+      AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
       lx_mip_found=yes
-      AC_DEFINE([LEMON_HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
+      AC_DEFINE([HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
       AC_MSG_RESULT([yes])
     else
Index: m4/lx_check_glpk.m4
===================================================================
--- m4/lx_check_glpk.m4	(revision 627)
+++ m4/lx_check_glpk.m4	(revision 459)
@@ -65,9 +65,9 @@
 
     if test x"$lx_glpk_found" = x"yes"; then
-      AC_DEFINE([LEMON_HAVE_GLPK], [1], [Define to 1 if you have GLPK.])
+      AC_DEFINE([HAVE_GLPK], [1], [Define to 1 if you have GLPK.])
       lx_lp_found=yes
-      AC_DEFINE([LEMON_HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+      AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
       lx_mip_found=yes
-      AC_DEFINE([LEMON_HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
+      AC_DEFINE([HAVE_MIP], [1], [Define to 1 if you have any MIP solver.])
       AC_MSG_RESULT([yes])
     else
Index: m4/lx_check_soplex.m4
===================================================================
--- m4/lx_check_soplex.m4	(revision 627)
+++ m4/lx_check_soplex.m4	(revision 539)
@@ -56,7 +56,7 @@
 
     if test x"$lx_soplex_found" = x"yes"; then
-      AC_DEFINE([LEMON_HAVE_SOPLEX], [1], [Define to 1 if you have SOPLEX.])
+      AC_DEFINE([HAVE_SOPLEX], [1], [Define to 1 if you have SOPLEX.])
       lx_lp_found=yes
-      AC_DEFINE([LEMON_HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+      AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
       AC_MSG_RESULT([yes])
     else
Index: test/CMakeLists.txt
===================================================================
--- test/CMakeLists.txt	(revision 627)
+++ test/CMakeLists.txt	(revision 621)
@@ -37,20 +37,20 @@
   unionfind_test)
 
-IF(LEMON_HAVE_LP)
+IF(HAVE_LP)
   ADD_EXECUTABLE(lp_test lp_test.cc)
   SET(LP_TEST_LIBS lemon)
-  IF(LEMON_HAVE_GLPK)
+  IF(HAVE_GLPK)
     SET(LP_TEST_LIBS ${LP_TEST_LIBS} ${GLPK_LIBRARIES})
-  ENDIF(LEMON_HAVE_GLPK)
-  IF(LEMON_HAVE_CPLEX)
+  ENDIF(HAVE_GLPK)
+  IF(HAVE_CPLEX)
     SET(LP_TEST_LIBS ${LP_TEST_LIBS} ${CPLEX_LIBRARIES})
-  ENDIF(LEMON_HAVE_CPLEX)
-  IF(LEMON_HAVE_CLP)
+  ENDIF(HAVE_CPLEX)
+  IF(HAVE_CLP)
     SET(LP_TEST_LIBS ${LP_TEST_LIBS} ${COIN_CLP_LIBRARIES})
-  ENDIF(LEMON_HAVE_CLP)
+  ENDIF(HAVE_CLP)
   TARGET_LINK_LIBRARIES(lp_test ${LP_TEST_LIBS})
   ADD_TEST(lp_test lp_test)
 
-  IF(WIN32 AND LEMON_HAVE_GLPK)
+  IF(WIN32 AND HAVE_GLPK)
     GET_TARGET_PROPERTY(TARGET_LOC lp_test LOCATION)
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
@@ -60,6 +60,6 @@
       COMMAND cmake -E copy ${GLPK_BIN_DIR}/zlib1.dll ${TARGET_PATH}
     )
-  ENDIF(WIN32 AND LEMON_HAVE_GLPK)
-  IF(WIN32 AND LEMON_HAVE_CPLEX)
+  ENDIF(WIN32 AND HAVE_GLPK)
+  IF(WIN32 AND HAVE_CPLEX)
     GET_TARGET_PROPERTY(TARGET_LOC lp_test LOCATION)
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
@@ -67,23 +67,23 @@
       COMMAND cmake -E copy ${CPLEX_BIN_DIR}/cplex91.dll ${TARGET_PATH}
     )
-  ENDIF(WIN32 AND LEMON_HAVE_CPLEX)
-ENDIF(LEMON_HAVE_LP)
+  ENDIF(WIN32 AND HAVE_CPLEX)
+ENDIF(HAVE_LP)
 
-IF(LEMON_HAVE_MIP)
+IF(HAVE_MIP)
   ADD_EXECUTABLE(mip_test mip_test.cc)
   SET(MIP_TEST_LIBS lemon)
-  IF(LEMON_HAVE_GLPK)
+  IF(HAVE_GLPK)
     SET(MIP_TEST_LIBS ${MIP_TEST_LIBS} ${GLPK_LIBRARIES})
-  ENDIF(LEMON_HAVE_GLPK)
-  IF(LEMON_HAVE_CPLEX)
+  ENDIF(HAVE_GLPK)
+  IF(HAVE_CPLEX)
     SET(MIP_TEST_LIBS ${MIP_TEST_LIBS} ${CPLEX_LIBRARIES})
-  ENDIF(LEMON_HAVE_CPLEX)
-  IF(LEMON_HAVE_CBC)
+  ENDIF(HAVE_CPLEX)
+  IF(HAVE_CBC)
     SET(MIP_TEST_LIBS ${MIP_TEST_LIBS} ${COIN_CBC_LIBRARIES})
-  ENDIF(LEMON_HAVE_CBC)
+  ENDIF(HAVE_CBC)
   TARGET_LINK_LIBRARIES(mip_test ${MIP_TEST_LIBS})
   ADD_TEST(mip_test mip_test)
 
-  IF(WIN32 AND LEMON_HAVE_GLPK)
+  IF(WIN32 AND HAVE_GLPK)
     GET_TARGET_PROPERTY(TARGET_LOC mip_test LOCATION)
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
@@ -93,6 +93,6 @@
       COMMAND cmake -E copy ${GLPK_BIN_DIR}/zlib1.dll ${TARGET_PATH}
     )
-  ENDIF(WIN32 AND LEMON_HAVE_GLPK)
-  IF(WIN32 AND LEMON_HAVE_CPLEX)
+  ENDIF(WIN32 AND HAVE_GLPK)
+  IF(WIN32 AND HAVE_CPLEX)
     GET_TARGET_PROPERTY(TARGET_LOC mip_test LOCATION)
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
@@ -100,6 +100,6 @@
       COMMAND cmake -E copy ${CPLEX_BIN_DIR}/cplex91.dll ${TARGET_PATH}
     )
-  ENDIF(WIN32 AND LEMON_HAVE_CPLEX)
-ENDIF(LEMON_HAVE_MIP)
+  ENDIF(WIN32 AND HAVE_CPLEX)
+ENDIF(HAVE_MIP)
 
 FOREACH(TEST_NAME ${TESTS})
Index: test/lp_test.cc
===================================================================
--- test/lp_test.cc	(revision 627)
+++ test/lp_test.cc	(revision 575)
@@ -26,17 +26,17 @@
 #endif
 
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
 #include <lemon/glpk.h>
 #endif
 
-#ifdef LEMON_HAVE_CPLEX
+#ifdef HAVE_CPLEX
 #include <lemon/cplex.h>
 #endif
 
-#ifdef LEMON_HAVE_SOPLEX
+#ifdef HAVE_SOPLEX
 #include <lemon/soplex.h>
 #endif
 
-#ifdef LEMON_HAVE_CLP
+#ifdef HAVE_CLP
 #include <lemon/clp.h>
 #endif
@@ -380,5 +380,5 @@
   lpTest(lp_skel);
 
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
   {
     GlpkLp lp_glpk1,lp_glpk2;
@@ -389,5 +389,5 @@
 #endif
 
-#ifdef LEMON_HAVE_CPLEX
+#ifdef HAVE_CPLEX
   try {
     CplexLp lp_cplex1,lp_cplex2;
@@ -400,5 +400,5 @@
 #endif
 
-#ifdef LEMON_HAVE_SOPLEX
+#ifdef HAVE_SOPLEX
   {
     SoplexLp lp_soplex1,lp_soplex2;
@@ -409,5 +409,5 @@
 #endif
 
-#ifdef LEMON_HAVE_CLP
+#ifdef HAVE_CLP
   {
     ClpLp lp_clp1,lp_clp2;
Index: test/mip_test.cc
===================================================================
--- test/mip_test.cc	(revision 627)
+++ test/mip_test.cc	(revision 575)
@@ -23,13 +23,13 @@
 #endif
 
-#ifdef LEMON_HAVE_CPLEX
+#ifdef HAVE_CPLEX
 #include <lemon/cplex.h>
 #endif
 
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
 #include <lemon/glpk.h>
 #endif
 
-#ifdef LEMON_HAVE_CBC
+#ifdef HAVE_CBC
 #include <lemon/cbc.h>
 #endif
@@ -130,5 +130,5 @@
 {
 
-#ifdef LEMON_HAVE_GLPK
+#ifdef HAVE_GLPK
   {
     GlpkMip mip1;
@@ -138,5 +138,5 @@
 #endif
 
-#ifdef LEMON_HAVE_CPLEX
+#ifdef HAVE_CPLEX
   try {
     CplexMip mip2;
@@ -148,5 +148,5 @@
 #endif
 
-#ifdef LEMON_HAVE_CBC
+#ifdef HAVE_CBC
   {
     CbcMip mip1;
Index: tools/dimacs-solver.cc
===================================================================
--- tools/dimacs-solver.cc	(revision 627)
+++ tools/dimacs-solver.cc	(revision 614)
@@ -201,5 +201,5 @@
     .boolOption("int","Use 'int' for capacities, costs etc. (default)")
     .optionGroup("datatype","int")
-#ifdef LEMON_HAVE_LONG_LONG
+#ifdef HAVE_LONG_LONG
     .boolOption("long","Use 'long long' for capacities, costs etc.")
     .optionGroup("datatype","long")
@@ -268,5 +268,5 @@
   else if(ap.given("ldouble"))
     solve<long double>(ap,is,os,desc);
-#ifdef LEMON_HAVE_LONG_LONG
+#ifdef HAVE_LONG_LONG
   else if(ap.given("long"))
     solve<long long>(ap,is,os,desc);