Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 430)
+++ lemon/bits/graph_adaptor_extender.h	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -25,13 +25,6 @@
 #include <lemon/bits/default_map.h>
 
-
-///\ingroup digraphbits
-///\file
-///\brief Extenders for the digraph adaptor types
 namespace lemon {
 
-  /// \ingroup digraphbits
-  ///
-  /// \brief Extender for the DigraphAdaptors
   template <typename _Digraph>
   class DigraphAdaptorExtender : public _Digraph {
@@ -65,12 +58,12 @@
     Node oppositeNode(const Node &n, const Arc &e) const {
       if (n == Parent::source(e))
-	return Parent::target(e);
+        return Parent::target(e);
       else if(n==Parent::target(e))
-	return Parent::source(e);
+        return Parent::source(e);
       else
-	return INVALID;
-    }
-
-    class NodeIt : public Node { 
+        return INVALID;
+    }
+
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -81,19 +74,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -104,19 +97,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -126,21 +119,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -150,43 +143,29 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &e) const {
       return Parent::target(e);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &e) const {
       return Parent::target(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &e) const {
       return Parent::source(e);
@@ -199,8 +178,8 @@
   ///
   /// \brief Extender for the GraphAdaptors
-  template <typename _Graph> 
+  template <typename _Graph>
   class GraphAdaptorExtender : public _Graph {
   public:
-    
+
     typedef _Graph Parent;
     typedef _Graph Graph;
@@ -211,5 +190,5 @@
     typedef typename Parent::Edge Edge;
 
-    // Graph extension    
+    // Graph extension
 
     int maxId(Node) const {
@@ -239,9 +218,9 @@
     Node oppositeNode(const Node &n, const Edge &e) const {
       if( n == Parent::u(e))
-	return Parent::v(e);
+        return Parent::v(e);
       else if( n == Parent::v(e))
-	return Parent::u(e);
+        return Parent::u(e);
       else
-	return INVALID;
+        return INVALID;
     }
 
@@ -256,5 +235,5 @@
 
 
-    class NodeIt : public Node { 
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -265,19 +244,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -288,19 +267,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -310,21 +289,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -334,20 +313,20 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    class EdgeIt : public Parent::Edge { 
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
+    class EdgeIt : public Parent::Edge {
       const Adaptor* _adaptor;
     public:
@@ -358,18 +337,18 @@
 
       explicit EdgeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Edge&>(*this));
-      }
-
-      EdgeIt(const Adaptor& adaptor, const Edge& e) : 
-	Edge(e), _adaptor(&adaptor) { }
-
-      EdgeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-    class IncEdgeIt : public Edge { 
+        _adaptor->first(static_cast<Edge&>(*this));
+      }
+
+      EdgeIt(const Adaptor& adaptor, const Edge& e) :
+        Edge(e), _adaptor(&adaptor) { }
+
+      EdgeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+    class IncEdgeIt : public Edge {
       friend class GraphAdaptorExtender;
       const Adaptor* _adaptor;
@@ -382,55 +361,35 @@
 
       IncEdgeIt(const Adaptor& adaptor, const Node &n) : _adaptor(&adaptor) {
-	_adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
+        _adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
       }
 
       IncEdgeIt(const Adaptor& adaptor, const Edge &e, const Node &n)
-	: _adaptor(&adaptor), Edge(e) {
-	direction = (_adaptor->u(e) == n);
+        : _adaptor(&adaptor), Edge(e) {
+        direction = (_adaptor->u(e) == n);
       }
 
       IncEdgeIt& operator++() {
-	_adaptor->nextInc(*this, direction);
-	return *this; 
-      }
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+        _adaptor->nextInc(*this, direction);
+        return *this;
+      }
+    };
+
     Node baseNode(const OutArcIt &a) const {
       return Parent::source(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &a) const {
       return Parent::target(a);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &a) const {
       return Parent::target(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &a) const {
       return Parent::source(a);
     }
 
-    /// Base node of the iterator
-    ///
-    /// Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::u(e) : Parent::v(e);
     }
-    /// Running node of the iterator
-    ///
-    /// Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::v(e) : Parent::u(e);